//
//  ClothesViewController.swift
//  Dry Cleaners Reminder
//
//  Created by EVO on 5/11/16.
//  Copyright © 2016 EVO. All rights reserved.
//

import UIKit
import CoreData


class ClothesViewController: UITableViewController, SwipeTableViewCellDelegate
{
    @IBOutlet var clothesTableView: UITableView!

    
    override func viewDidLoad()
    {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        
        // Set navigation bar color
        navigationController!.navigationBar.tintColor = UIColor(red: 204.0/255.0, green: 0.0/255.0, blue: 0.0/255.0, alpha: 1.0)
        
        // Set navigation bar title color
        navigationController!.navigationBar.titleTextAttributes = [ NSForegroundColorAttributeName: UIColor(red: 204.0/255.0, green: 0.0/255.0, blue: 0.0/255.0, alpha: 1.0), NSFontAttributeName: UIFont(name: "Futura-Medium", size: 20)! ]
        
        // Remove extra unfilled rows in the table
        clothesTableView.tableFooterView = UIView()
    }
    
    /*
     * MARK: UITABLEVIEWDELEGATE
     *
     * This function sets the number of sections.
     */
    override func numberOfSections(in tableView: UITableView) -> Int
    {
        return 1
    }
    
    /*
     * This function sets the number of rows per section.
     */
    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int
    {
        return 1
    }
    
    /*
     * This function populates each cell with data.
     */
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell
    {
        // Dequeue the cell to load data
        let cell: SwipeTableViewCell = tableView.dequeueReusableCell(withIdentifier: "ClothesCell", for: indexPath) as! SwipeTableViewCell
        
        cell.delegate = self
        
        // Retrieve the cell's properties
        let clothesThumbnail = cell.viewWithTag(1) as! UIImageView
        let clothesTitle = cell.viewWithTag(2) as! UILabel
        let clothesDescription = cell.viewWithTag(3) as! UILabel

        // Store the details of the clothing
        clothesTitle.text = "test"
        clothesDescription.text = "test"
        clothesThumbnail.image = #imageLiteral(resourceName: "placeholder")

        clothesThumbnail.contentMode = UIViewContentMode.scaleAspectFill

        // Add black border around image
        clothesThumbnail.layer.borderColor = UIColor.black.cgColor
        clothesThumbnail.layer.borderWidth = 1.0
        clothesThumbnail.clipsToBounds = true
        
        // Return the cell with loaded data
        return cell
    }
    
    /*
     * This function allows the editing of each cell, i.e. delete a cell or insert a new cell.
     */
    override func tableView(_ tableView: UITableView, commit editingStyle: UITableViewCellEditingStyle, forRowAt indexPath: IndexPath)
    {

    }
    
    func tableView(_ tableView: UITableView, editActionsForRowAt indexPath: IndexPath, for orientation: SwipeActionsOrientation) -> [SwipeAction]?
    {
        guard orientation == .right else
        {
            return nil
        }
        
        let deleteAction = SwipeAction(style: .default, title: "Delete") { action, indexPath in
              
        }
        
        // customize the action appearance
        deleteAction.image = #imageLiteral(resourceName: "button_delete")
        
        deleteAction.backgroundColor = UIColor(red: 227.0/255.0, green: 46.0/255.0, blue: 7.0/255.0, alpha: 1.0)

        deleteAction.font = UIFont(name: "Futura-Medium", size: 15.0)
        
        let editAction = SwipeAction(style: .default, title: "Edit") { action, indexPath in
            // handle action by updating model with deletion
            
        self.performSegue(withIdentifier: "Testies", sender: self)
        }
        
        // customize the action appearance
        editAction.image = #imageLiteral(resourceName: "button_edit")
        
        editAction.backgroundColor = UIColor(red: 112.0/255.0, green: 134.0/255.0, blue: 247.0/255.0, alpha: 1.0)

        editAction.font = UIFont(name: "Futura-Medium", size: 15.0)
        
        let dirtyAction = SwipeAction(style: .default, title: "Dirty") { action, indexPath in
            // handle action by updating model with deletion
        }
        
        // customize the action appearance
        dirtyAction.image = #imageLiteral(resourceName: "button_dirty")
        
        
        
        dirtyAction.backgroundColor = UIColor(red: 163.0/255.0, green: 116.0/255.0, blue: 44.0/255.0, alpha: 1.0)
        
        dirtyAction.font = UIFont(name: "Futura-Medium", size: 15.0)
        
        return [deleteAction, editAction, dirtyAction]
    }

    
    func tableView(_ tableView: UITableView, editActionsOptionsForRowAt indexPath: IndexPath, for orientation: SwipeActionsOrientation) -> SwipeTableOptions
    {
        var options = SwipeTableOptions()
        
        options.expansionStyle = .none
        options.transitionStyle = .border
        options.maximumButtonWidth = 0
        options.buttonPadding = 0
        
        return options
    }
    
    /*
     * This function sets the height of each cell.
     */
    override func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat
    {
        return 140.0
    }
    
    /*
     * This function sets the height of each section header cell.
     */
    override func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat
    {
        return 30.0
    }
    
    /*
     * MARK: UITABLEVIEWDATASOURCE
     *
     * This function monitors the selection of a row.
     */
    override func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath)
    {
        // Deselects the row
        tableView.deselectRow(at: indexPath, animated: true)
    }
}
